import { TrackballControls } from "https://cdn.skypack.dev/three-trackballcontrols-ts@0.2.3";
let scene, camera, renderer, cube, cube2, controls;

let addTrackBall = () => {
  //Trackball Controls for Camera 
  controls = new TrackballControls(camera, renderer.domElement);
  controls.rotateSpeed = 4;
  controls.dynamicDampingFactor = 0.15;
}

let createBox = () => {
  const colorBlue = new THREE.Color(0x7658ef);
  const boxGeometry = new THREE.BoxGeometry(2, 2, 2);
  const boxMaterial = new THREE.MeshPhongMaterial({ color: colorBlue, shininess: 60 });
  cube = new THREE.Mesh(boxGeometry, boxMaterial);
  cube.rotation.set(40, 0, 40);
  scene.add(cube);
}

let createBox2 = () => {
  const colorBlue = new THREE.Color(0x7658ef);
  const boxGeometry = new THREE.BoxGeometry(1, 1, 1);
  const boxMaterial = new THREE.MeshPhongMaterial({ color: colorBlue, shininess: 60 });
  cube2 = new THREE.Mesh(boxGeometry, boxMaterial);
  cube2.rotation.set(40, 0, 40);
  cube2.position.set(3, 0, 0);
  scene.add(cube2);
}

let addLights = () => {
  const colorLight = new THREE.Color("hsl(41, 100%, 95%)");
  const light = new THREE.PointLight(colorLight, 2);
  const light2 = new THREE.PointLight(colorLight, .5);
  light.position.set(-40, -20, 20);
  light2.position.set(40, 20, 15);
  scene.add(light);
  scene.add(light2);
}
let init = () => {
  scene = new THREE.Scene();
  camera = new THREE.PerspectiveCamera(75, window.innerWidth / window.innerHeight, 0.1, 1000);
  camera.position.z = 5;
  renderer = new THREE.WebGLRenderer({ antialias: true, alpha: true });
  renderer.setSize(window.innerWidth, window.innerHeight);
  document.body.appendChild(renderer.domElement);
  createBox();
  createBox2();
  addLights();
  addTrackBall();
  window.addEventListener('resize', onWindowResize, false);
}

let animate=()=> {
  requestAnimationFrame(animate);
  renderer.render(scene, camera);
  cube.rotation.x += 0.01;
  cube.rotation.y += 0.01;
  cube2.rotation.x += 0.02;
  cube2.rotation.y += 0.02;
  // Update trackball controls
  controls.update();
}

let onWindowResize = () => {
  camera.aspect = window.innerWidth / window.innerHeight;
  camera.updateProjectionMatrix();
  renderer.setSize(window.innerWidth, window.innerHeight);
}

init();
animate();